//*****************************************************************************
//*
//*
//*		MainFrm.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"MainFrm.h"
#include	"NetStatEx.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif



IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FIXWINDOW					,OnFixWindow)
	ON_COMMAND(ID_STATUS_BAR_FLAT			,OnFlatBar)
	ON_UPDATE_COMMAND_UI(ID_FIXWINDOW		,OnFixWindowUI)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT	,OnFlatBarUI)
	//}}AFX_MSG_MAP
	ON_MENUICON_MODE()
	ON_MENUICON()
END_MESSAGE_MAP()

static UINT indicators[] =
	{
	ID_SEPARATOR,												// status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	};


MENUICON_PROC(CMainFrame)

//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
//  CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
CRegKeys	sKey;


	m_bFlatMode		= TRUE;
	m_bWindowFixed	= FALSE;

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Get(m_bFlatMode,_T("FlatMode"));
	sKey.Get(m_bMenuMode,_T("MenuMode"));

}

//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Set(m_bFlatMode,_T("FlatMode"));
	sKey.Set(m_bMenuMode,_T("MenuMode"));

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
DWORD	dwStyle;


	if(CFrameWnd::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;

	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;
		}

	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;
		}

	if(!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Failed to create status bar\n");
		return -1;
		}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit (IDR_MAINFRAME);


return 0;
}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &cs)
{
	if(!CFrameWnd::PreCreateWindow(cs))
		{
		return FALSE;
		}

return TRUE;
}

#ifdef		_DEBUG

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CMainFrame::Dump(CDumpContext &dc) const
{
	CFrameWnd::Dump(dc);
}

#endif

//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode=(dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}


}

//*****************************************************************************
//*
//*		OnFixWindowUI
//*
//*****************************************************************************
void CMainFrame::OnFixWindowUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bWindowFixed);
}

//*****************************************************************************
//*
//*		OnFixWindow
//*
//*****************************************************************************
void CMainFrame::OnFixWindow()
{
	m_bWindowFixed = !m_bWindowFixed;
	SetWindowPos((m_bWindowFixed)? &wndTopMost:&wndNoTopMost,0,0,0,0,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE);
}





