//*****************************************************************************
//*
//*
//*		MainFrm.cpp
//*
//*
//*****************************************************************************
// MainFrm.cpp : implementation of the CMainFrame class
//
#include	"StdAfx.h"
#include	"NetStatEx.h"
#include	"ConnectDlg.h"
#include	"NetStatExDoc.h"
#include	"NetStatExView.h"
#include	"MainFrm.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_UPDATE_BAR		0x1000
#define 	 ID_CONNECT_BAR		0x1001

#define 	 MODE_DISCONNECTED	0
#define 	 MODE_CONNECTED		1
#define 	 MODE_BROKEN		2

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_COMMAND(ID_CONNECT					,OnConnect)
	ON_COMMAND(ID_DISCONNECT				,OnDisconnect)
	ON_COMMAND(ID_FIXWINDOW					,OnFixWindow)
	ON_COMMAND(ID_STATUS_BAR_FLAT			,OnFlatBar)
	ON_UPDATE_COMMAND_UI(ID_CONNECT			,OnConnectUI)
	ON_UPDATE_COMMAND_UI(ID_DISCONNECT		,OnDisconnectUI)
	ON_UPDATE_COMMAND_UI(ID_FIXWINDOW		,OnFixWindowUI)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT	,OnFlatBarUI)
	//}}AFX_MSG_MAP
	ON_STATUSBARDRAW()
	ON_MENUICON_MODE()
	ON_STATUSBAR()
	ON_MENUICON()
END_MESSAGE_MAP()

static UINT indicators[] =
	{
	ID_SEPARATOR,												// status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	};


MENUICON_PROC(CMainFrame)
STATUSBAR_PROC(CMainFrame)


extern	int  NetStatInit();
extern	int  NetStatExit();
extern	int  NetStatConnState();
extern	int  NetStatDisconnect();
extern	int  NetStatConnect(const char *pServer,int iPort,const char *pLogin,const char *pPassword,int iMode,int iTiemout);

char	cServerName[64];


//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
//  CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
CRegKeys	sKey;


	m_bFlatMode		= TRUE;
	m_bWindowFixed	= FALSE;

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Get(m_bFlatMode,_T("FlatMode"));
	sKey.Get(m_bMenuMode,_T("MenuMode"));

	NetStatInit();


}

//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;


	NetStatExit();

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Set(m_bFlatMode,_T("FlatMode"));
	sKey.Set(m_bMenuMode,_T("MenuMode"));

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
int 	aStatusId[]={ID_CONNECT_BAR};
int 	aStatusSz[]={90            };
DWORD	dwStyle;
int		iPos;


	if(CFrameWnd::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;

	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;
		}

	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;
		}

	if(!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Failed to create status bar\n");
		return -1;
		}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit (IDR_MAINFRAME);

	StatusbarInit();
	StatusbarAdd(aStatusId,aStatusSz,sizeof(aStatusId)/sizeof(aStatusId[0]));

	   iPos =  m_wndStatusBar.CommandToIndex(ID_CONNECT_BAR);
	if(iPos>=0)m_wndStatusBar.GetStatusBarCtrl().SetText((LPCTSTR)this,iPos,SBT_OWNERDRAW);


	SetTimer(ID_UPDATE_BAR,600,NULL);


return 0;
}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &cs)
{
	if(!CFrameWnd::PreCreateWindow(cs))
		{
		return FALSE;
		}

return TRUE;
}

#ifdef		_DEBUG

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CMainFrame::Dump(CDumpContext &dc) const
{
	CFrameWnd::Dump(dc);
}

#endif

//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode=(dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}


}

//*****************************************************************************
//*
//*		OnFixWindowUI
//*
//*****************************************************************************
void CMainFrame::OnFixWindowUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bWindowFixed);
}

//*****************************************************************************
//*
//*		OnFixWindow
//*
//*****************************************************************************
void CMainFrame::OnFixWindow()
{
	m_bWindowFixed = !m_bWindowFixed;
	SetWindowPos((m_bWindowFixed)? &wndTopMost:&wndNoTopMost,0,0,0,0,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE);
}

//*****************************************************************************
//*
//*		OnConnectUI
//*
//*****************************************************************************
void CMainFrame::OnConnectUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(NetStatConnState()==MODE_DISCONNECTED);
}

//*****************************************************************************
//*
//*		OnConnect
//*
//*****************************************************************************
void CMainFrame::OnConnect()
{
CNetStatExView	   *pView;
CConnectDlg			sDlg;


	if(sDlg.DoModal()!=IDOK)return;

	strlcpy(cServerName,sDlg.m_sServer,sizeof(cServerName));

	   pView = (CNetStatExView*)GetActiveView();
	if(pView)pView->Delete(0);

	if(NetStatConnect(sDlg.m_sServer,sDlg.m_iPort,sDlg.m_sLogin,sDlg.m_sPassword,sDlg.m_iMode|0x80,0))
		{
		MessageBox("Es gab einen Fehler beim Verbindungsaufbau !","Fehler",MB_OK|MB_ICONERROR);
		}

}

//*****************************************************************************
//*
//*		OnDisconnectUI
//*
//*****************************************************************************
void CMainFrame::OnDisconnectUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(NetStatConnState()!=MODE_DISCONNECTED);
}

//*****************************************************************************
//*
//*		OnDisconnect
//*
//*****************************************************************************
void CMainFrame::OnDisconnect()
{

	NetStatDisconnect();

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CMainFrame::OnTimer(UINT_PTR nIdEvent)
{
char		cText[256];
static int 	iLast=-1;
int			iState;
int			iPos;



	if(nIdEvent==ID_UPDATE_BAR)
		{
		   iState = NetStatConnState();
		if(iState==iLast)return;

		if(!iState)
			{
			SetWindowText("Offline - NetStat");
			}
		else{
			sprintf(cText,"%s - NetStat",cServerName);
			SetWindowText(cText);
			}

		iLast = iState;

		   iPos =  m_wndStatusBar.CommandToIndex(ID_CONNECT_BAR);
		if(iPos>=0)m_wndStatusBar.GetStatusBarCtrl().SetText((LPCTSTR)this,iPos,SBT_OWNERDRAW);

		return;
		}


	CMainFrame::OnTimer(nIdEvent);
}

//*****************************************************************************
//*
//*		OnDrawStatusBar
//*
//*****************************************************************************
void CMainFrame::OnDrawStatusBar(CStatusBar *pBar,LPDRAWITEMSTRUCT pDraw)
{
LPCTSTR	pText;
int		iPosX;
int		iPosY;
int		iLen;
HDC		hDc;



	hDc		= pDraw->hDC;

	switch(pDraw->itemID)
		{
	case 1:													// Verbindungszustand

		switch(NetStatConnState())
			{
		case MODE_CONNECTED:

				SetBkColor  (hDc,RGB(100,200,100));
				SetTextColor(hDc,RGB(255,255,  0));
				pText	= "Connected";
				iLen	= 9;
				break;

		case MODE_BROKEN:

				SetBkColor  (hDc,RGB(255,178,178));
				SetTextColor(hDc,RGB(255, 60,  0));
				pText	= "Broken";
				iLen	= 6;
				break;

		default:

				SetBkColor  (hDc,RGB(158,158,255));
				SetTextColor(hDc,RGB(  0,  0,255));
				pText	= "Disconnected";
				iLen	= 12;
				break;
			}


		iPosX	= (pDraw->rcItem.right +pDraw->rcItem.left)/2;
		iPosY	= (pDraw->rcItem.bottom-1);

		SetTextAlign(hDc,TA_CENTER|TA_BOTTOM);
		ExtTextOut(hDc,iPosX,iPosY,ETO_OPAQUE|ETO_CLIPPED,&pDraw->rcItem,pText,iLen,NULL);
		break;
		}

}

