//*****************************************************************************
//*
//*
//*		NetStatExView.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"NetStatEx.h"
#include	"NetStatExDoc.h"
#include	"NetStatExView.h"

#define 	 ID_DONE		0x4591
#define 	 ID_LIST		0x4592
#define 	 ID_SCAN		0x4593
#define 	 ID_TICK		0x4594
#define 	 ID_COPYITEM	0x4595
#define 	 ID_PASTEITEM	0x4596
#define 	 ID_SETFILTER	0x4597
#define 	 ID_SETDUALFL	0x4598
#define 	 ID_DELFILTER	0x4599

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CNetStatExView, CView)

BEGIN_MESSAGE_MAP(CNetStatExView, CView)
	//{{AFX_MSG_MAP(CNetStatExView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_CUT,					OnEditCut)
	ON_COMMAND(ID_EDIT_COPY,				OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE,				OnEditPaste)
	ON_COMMAND(ID_CLEARFILTER,				OnClearFilter)
	ON_COMMAND(ID_AUTOUPDATE,				OnAutoUpdate)
	ON_UPDATE_COMMAND_UI(ID_AUTOUPDATE,		OnAutoUpdateUI)
	//}}AFX_MSG_MAP
	ON_MESSAGE(ID_DONE,						OnDone)
	ON_COMMAND(ID_COPYITEM,					OnCopyItem)
	ON_COMMAND(ID_PASTEITEM,				OnPasteItem)
	ON_COMMAND(ID_SETFILTER,				OnSetFilter)
	ON_COMMAND(ID_SETDUALFL,				OnSetDualFl)
	ON_COMMAND(ID_DELFILTER,				OnDelFilter)
	ON_NOTIFY(TVN_COLUMNCLICK	, ID_LIST , OnListSort)
	ON_NOTIFY(TVN_COLUMNDBLCLICK, ID_LIST , OnListSort)
	ON_NOTIFY(TVN_STARTEDIT		, ID_LIST , OnListStartEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT  , ID_LIST , OnListEndEdit)
END_MESSAGE_MAP()

int		CNetStatExView::m_iScanRun=0;

//*****************************************************************************
//*
//*		CNetStatExView
//*
//*****************************************************************************
CNetStatExView::CNetStatExView()
{
CRegKeys	sKey;
CString		sStr;
LPTSTR		pTxt;
int			iPos;


	m_uFilter			= 0x0F;
	m_uFilterState		= 0;
	m_uTurn				= 0;
	m_pScan				= 0;
	m_iDoEdit			= 0;
	m_iSortOn			= 0;
	m_bNewFlag			= 0;
	m_bAutoUpdate		= 1;

	m_iSortDir			= 0;
	m_aSortList[0]		= 0;
	m_aSortList[1]		= 2;
	m_aSortList[2]		= 1;
	m_aSortList[3]		= 0xFF;

	m_aFilterLocPort[0]	= -1;
	m_aFilterRemPort[0]	= -1;
	m_aFilterProcess[0]	= -1;
	m_aFilterLocAddr[0]	= 0;
	m_aFilterRemAddr[0]	= 0;
	m_aFilterName   [0]	= 0;
	m_aFilterPath   [0]	= 0;

	memset(m_aFilterLocDual,0,sizeof(m_aFilterLocDual));
	memset(m_aFilterRemDual,0,sizeof(m_aFilterRemDual));

	sKey.Open();
	sKey.Get(m_bAutoUpdate	,"AutoUpdate");
	sKey.Get(m_uFilter		,"FilterType");
	sKey.Get(m_uFilterState	,"FilterState");
	sKey.Get(m_aFilterLocDual,sizeof(m_aFilterLocDual),"FilterLocalDual" );
	sKey.Get(m_aFilterRemDual,sizeof(m_aFilterRemDual),"FilterRemoteDual");
	sKey.Get(m_aFilterLocPort,sizeof(m_aFilterLocPort),"FilterLocalPort" );
	sKey.Get(m_aFilterRemPort,sizeof(m_aFilterRemPort),"FilterRemotePort");
	sKey.Get(m_aFilterProcess,sizeof(m_aFilterProcess),"FilterProcessId" );
	sKey.Get(m_aFilterLocAddr,"FilterLocalAddr" );
	sKey.Get(m_aFilterRemAddr,"FilterRemoteAddr");
	sKey.Get(m_aFilterName   ,"FilterProcessName");
	sKey.Get(m_aFilterPath   ,"FilterProcessPath");


	for(iPos=0;iPos<9;iPos++)
		{
		m_aLastFilters[iPos].ContainerInit();

			sStr.Format("Last%i",iPos);
		if(!sKey.GetMulti(&pTxt,sStr))continue;

		m_aLastFilters[iPos].CAdd(&pTxt);

		delete pTxt;
		}


}

//*****************************************************************************
//*
//*		CNetStatExView
//*
//*****************************************************************************
CNetStatExView::~CNetStatExView()
{
CRegKeys	sKey;
CString		sStr;
LPTSTR		pTxt;
int			iPos;


	NetStatFree(m_pScan);

	sKey.Open();
	sKey.Set(m_bAutoUpdate	,"AutoUpdate");
	sKey.Set(m_uFilter		,"FilterType");
	sKey.Set(m_uFilterState ,"FilterState");
	sKey.Set(m_aFilterLocDual,sizeof(m_aFilterLocDual),"FilterLocalDual" );
	sKey.Set(m_aFilterRemDual,sizeof(m_aFilterRemDual),"FilterRemoteDual");
	sKey.Set(m_aFilterLocPort,sizeof(m_aFilterLocPort),"FilterLocalPort" );
	sKey.Set(m_aFilterRemPort,sizeof(m_aFilterRemPort),"FilterRemotePort");
	sKey.Set(m_aFilterProcess,sizeof(m_aFilterProcess),"FilterProcessId" );
	sKey.Set(m_aFilterLocAddr,"FilterLocalAddr" );
	sKey.Set(m_aFilterRemAddr,"FilterRemoteAddr");
	sKey.Set(m_aFilterName   ,"FilterProcessName");
	sKey.Set(m_aFilterPath   ,"FilterProcessPath");


	for(iPos=0;iPos<9;iPos++)
		{
		sStr.Format("Last%i",iPos);
		m_aLastFilters[iPos].Chain(&pTxt);
		sKey.SetMulti(pTxt,sStr);
		delete pTxt;
		}

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CNetStatExView::PreCreateWindow(CREATESTRUCT &sCreate)
{

return CView::PreCreateWindow(sCreate);
}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
//  CNetStatExView drawing
void CNetStatExView::OnDraw(CDC *pDC)
{
CNetStatExDoc  *pDoc = GetDocument();



	ASSERT_VALID(pDoc);
}

#ifdef		_DEBUG

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CNetStatExView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CNetStatExView::Dump(CDumpContext &dc) const
{
	CView::Dump(dc);
}

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
CNetStatExDoc *CNetStatExView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNetStatExDoc)));
		   #ifdef _DEBUG
#endif // _DEBUG

return (CNetStatExDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CNetStatExView::OnCreate(LPCREATESTRUCT pCreateStruct)
{
char			cText[256];
HANDLE			hThread;
DWORD			uThread;
HTREEITEM		hItem;
int				iSize;
int				iLen;
int				iPos;


	if(CView::OnCreate(pCreateStruct) == -1)
		{
		return -1;
		}

	m_cList.Create(WS_VISIBLE|WS_CHILD|TVS_EDITLABELS|TVS_FULLROWSELECT,CRect(0,0,0,0),this,ID_LIST);
	m_cList.SetExtendedStyle(TVS_EX_ALTERNATECOLOR|TVS_EX_FULLROWMARK|TVS_EX_HOMEENDSELECT|TVS_EX_ITEMLINES|TVS_EX_SUBSELECT);
	m_cList.SetUserDataSize(sizeof(m_cList));
	m_cList.SetOption(TVOP_FIXEDLINES ,1);
	m_cList.SetOption(TVOP_FIXEDALWAYS,1);

	iSize = GetSystemMetrics(SM_CXICON);

	m_cList.InsertColumn(0,"Mode"			,TVCFMT_LEFT , 50*iSize/32);
	m_cList.InsertColumn(1,"Lokales Port"	,TVCFMT_RIGHT,-12);
	m_cList.InsertColumn(2,"Lokale IP"		,TVCFMT_LEFT ,-20);
	m_cList.InsertColumn(3,"Remote Port"	,TVCFMT_RIGHT,-12);
	m_cList.InsertColumn(4,"Remote IP"		,TVCFMT_LEFT ,-20);
	m_cList.InsertColumn(5,"Status"			,TVCFMT_LEFT ,-14);
	m_cList.InsertColumn(6,"PID"			,TVCFMT_RIGHT,-10);
	m_cList.InsertColumn(7,"Prozess"		,TVCFMT_LEFT ,-20);
	m_cList.InsertColumn(8,"Pfad"			,TVCFMT_LEFT ,-50);

	hItem = m_cList.InsertItem("");
	m_cList.SetItemBkColor(hItem,-1,RGB(240,255,240));

	if(m_uFilter==0x0F)m_cList.SetItemText(hItem,"All");
	if(m_uFilter==0x05)m_cList.SetItemText(hItem,"Tcp");
	if(m_uFilter==0x0A)m_cList.SetItemText(hItem,"Udp");
	if(m_uFilter==0x01)m_cList.SetItemText(hItem,"Tcp V4");
	if(m_uFilter==0x02)m_cList.SetItemText(hItem,"Udp V4");
	if(m_uFilter==0x04)m_cList.SetItemText(hItem,"Tcp V6");
	if(m_uFilter==0x08)m_cList.SetItemText(hItem,"Udp V6");


	cText[0] = 0;
	iLen     = 0;

	for(iPos=0;iPos<8;iPos++)
		{
		if(m_aFilterLocPort[iPos]<0)break;
		iLen+=sprintf(cText+iLen,"%s%s%i",(iPos)? ";":"",(m_aFilterLocDual[iPos])? "-":"",m_aFilterLocPort[iPos]);
		}

	m_cList.SetItemText(hItem,cText,1);
	m_cList.SetItemText(hItem,m_aFilterLocAddr,2);


	cText[0] = 0;
	iLen     = 0;

	for(iPos=0;iPos<8;iPos++)
		{
		if(m_aFilterRemPort[iPos]<0)break;
		iLen+=sprintf(cText+iLen,"%s%s%i",(iPos)? ";":"",(m_aFilterRemDual[iPos])? "-":"",m_aFilterRemPort[iPos]);
		}

	m_cList.SetItemText(hItem,cText,3);
	m_cList.SetItemText(hItem,m_aFilterRemAddr,4);

	cText[0] = 0;
	iLen     = 0;

	for(iPos=0;iPos<8;iPos++)
		{
		if(m_aFilterProcess[iPos]<0)break;
		iLen+=sprintf(cText+iLen,"%s%i",(iPos)? ";":"",m_aFilterProcess[iPos]);
		}

	if(m_uFilterState)
		{
		m_cList.SetItemText(hItem,NetStatState(m_uFilterState-1),5);
		}
	else{
		m_cList.SetItemText(hItem,"All",5);
		}


	m_cList.SetItemText(hItem,cText,6);

	m_cList.SetItemText(hItem,m_aFilterName,7);
	m_cList.SetItemText(hItem,m_aFilterPath,8);


	m_iScanRun = 1;
	hThread = CreateThread(NULL,0x10000,ScanThread,this,0,&uThread);
	CloseHandle(hThread);

	SetTimer(ID_SCAN,5000,NULL);
	SetTimer(ID_TICK, 250,NULL);

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,NULL);


return 0;
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CNetStatExView::OnSize(UINT nType,int iSizeX,int iSizeY)
{

	CView::OnSize(nType,iSizeX,iSizeY);

	if(iSizeX && iSizeY)
		{
		SizeWindow(&m_cList,iSizeX,iSizeY);
		}


}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CNetStatExView::OnTimer(UINT_PTR nIDEvent)
{
HANDLE			hThread;
DWORD			uThread;


	if(nIDEvent==ID_SCAN)
		{
		if(m_bAutoUpdate==0)return;
		if(m_iSortOn       )return;

		if(!m_iScanRun)
			{
			m_iScanRun = 1;
			hThread = CreateThread(NULL,0x10000,ScanThread,this,0,&uThread);
			CloseHandle(hThread);
			}

		return;
		}

	if(nIDEvent==ID_TICK)
		{
		if(!m_bNewFlag)return;
		m_bNewFlag=FALSE;
		Scan(m_pScan);
		return;
		}


	CView::OnTimer(nIDEvent);
}


//*****************************************************************************
//*
//*		StateColor
//*
//*****************************************************************************
COLORREF CNetStatExView::StateColor(unsigned uState)
{

	if(GetWindowsVersion()<0x00060000)
		{
		switch(uState)
			{
		case NSL_TCP_STATE_FIN_WAIT1:
		case NSL_TCP_STATE_FIN_WAIT2:
		case NSL_TCP_STATE_CLOSE_WAIT:
		case NSL_TCP_STATE_CLOSED:
		case NSL_TCP_STATE_CLOSING:
		case NSL_TCP_STATE_DELETE_TCB:	return RGB(110,110,110);
		case NSL_TCP_STATE_UDP:			return RGB(  0,120,120);
		case NSL_TCP_STATE_LISTEN:		return RGB(  0,120,  0);
		case NSL_TCP_STATE_ESTAB:		return RGB(  0,  0,150);
			}

		return RGB(120,  0,120);
		}


	switch(uState)
		{
	case NSL_TCP_STATE_FIN_WAIT1:
	case NSL_TCP_STATE_FIN_WAIT2:
	case NSL_TCP_STATE_CLOSE_WAIT:
	case NSL_TCP_STATE_CLOSED:
	case NSL_TCP_STATE_CLOSING:
	case NSL_TCP_STATE_DELETE_TCB:	return RGB( 70, 70, 70);
	case NSL_TCP_STATE_UDP:			return RGB(  0, 80, 80);
	case NSL_TCP_STATE_LISTEN:		return RGB(  0, 80,  0);
	case NSL_TCP_STATE_ESTAB:		return RGB(  0,  0,100);
		}


return RGB( 80,  0, 80);
}

//*****************************************************************************
//*
//*		Sort
//*
//*****************************************************************************
void CNetStatExView::Sort()
{
LRESULT		lResult;
NMHEADER	sHeader;


	lResult			= 0;
	m_iSortDir		= m_iSortDir==0;
	sHeader.iItem	= m_aSortList[0];

	OnListSort(&sHeader.hdr,&lResult);

}

//*****************************************************************************
//*
//*		Scan
//*
//*****************************************************************************
void CNetStatExView::Scan(NetStatEntry *pScan)
{
const char     *pTypes[4]={"TCP V4","UDP V4","TCP V6","UDP V6"};
ListUserData   *pUser;
char			cText[64];
UINT			uChanged;
UINT			uItemRow;
UINT			uFirst;
CompareData		sData;
HTREEITEM		hNext;
HTREEITEM		hItem;
LPCTSTR			pName;
LPCTSTR			pPath;
unsigned		uPos;
unsigned		uOff;
unsigned		uBit;
unsigned		uCrc;
unsigned		uLen;



	if(!pScan)return;

	m_uTurn++;
	uChanged = 0;

	for(uPos=0;pScan[uPos].ucType!=0xFF;uPos++)
		{
		uBit = 1<<pScan[uPos].ucType;

		if(!(uBit&m_uFilter))continue;

		if(m_uFilterState && m_uFilterState-1!=pScan[uPos].ucState)
			{
			continue;
			}

		if(m_aFilterLocPort[0]!=-1)
			{
			for(uOff=0;uOff<8;uOff++)
				{
				if(m_aFilterLocPort[uOff]==-1){uOff=8;break;}
				if(m_aFilterLocPort[uOff]==pScan[uPos].usLocalPort )break;
				if(m_aFilterLocDual[uOff]== 0)continue;
				if(m_aFilterLocPort[uOff]==pScan[uPos].usRemotePort)break;
				}

			if(uOff>=8)continue;
			}


		if(m_aFilterRemPort[0]!=-1)
			{
			for(uOff=0;uOff<8;uOff++)
				{
				if(m_aFilterRemPort[uOff]==-1){uOff=8;break;}
				if(m_aFilterRemPort[uOff]==pScan[uPos].usRemotePort)break;
				if(m_aFilterRemDual[uOff]== 0)continue;
				if(m_aFilterRemPort[uOff]==pScan[uPos].usLocalPort )break;
				}

			if(uOff>=8)continue;
			}

		if(m_aFilterProcess[0]!=-1)
			{
			for(uOff=0;uOff<8;uOff++)
				{
				if(m_aFilterProcess[uOff]==-1){uOff=8;break;}
				if(!(m_aFilterProcess[uOff]^pScan[uPos].uProcessId))break;
				}

			if(uOff>=8)continue;
			}

		if(m_aFilterLocAddr[0])
			{
			uOff = 0;

			for(;;)
				{
				uLen = strchar(m_aFilterLocAddr+uOff,';');
				if(!memxcmp(m_aFilterLocAddr+uOff,uLen,pScan[uPos].cLocalAddr,strlen(pScan[uPos].cLocalAddr),0x01))
					{
					break;
					}

				uOff += uLen;

				if(m_aFilterLocAddr[uOff]==0)break;

				uOff++;
				}

			if(m_aFilterLocAddr[uOff]==0)continue;
			}

		if(m_aFilterRemAddr[0])
			{
			uOff = 0;

			for(;;)
				{
				uLen = strchar(m_aFilterRemAddr+uOff,';');
				if(!memxcmp(m_aFilterRemAddr+uOff,uLen,pScan[uPos].cRemoteAddr,strlen(pScan[uPos].cRemoteAddr),0x01))
					{
					break;
					}

				uOff += uLen;

				if(m_aFilterRemAddr[uOff]==0)break;

				uOff++;
				}

			if(m_aFilterRemAddr[uOff]==0)continue;
			}

		if(m_aFilterName[0])
			{
			uOff = 0;

			for(;;)
				{
				uLen = strchar(m_aFilterName+uOff,';');
				if(!memxcmp(m_aFilterName+uOff,uLen,pScan[uPos].pProcessName,strlen(pScan[uPos].pProcessName),0x01))
					{
					break;
					}

				uOff += uLen;

				if(m_aFilterName[uOff]==0)break;

				uOff++;
				}

			if(m_aFilterName[uOff]==0)continue;
			}

		if(m_aFilterPath[0])
			{
			uOff = 0;

			for(;;)
				{
				uLen = strchar(m_aFilterPath+uOff,';');
				if(!memxcmp(m_aFilterPath+uOff,uLen,pScan[uPos].pProcessPath,strlen(pScan[uPos].pProcessPath),0x01))
					{
					break;
					}

				uOff += uLen;

				if(m_aFilterPath[uOff]==0)break;

				uOff++;
				}

			if(m_aFilterPath[uOff]==0)continue;
			}


		uCrc = CalcCrc(pScan+uPos);


		if(m_pScan)										// Suche bereits eingefgte Eintrge
			{
			hItem = m_cList.FindItemEx(TVI_ROOT,uCrc);

			for(;hItem;hItem=m_cList.FindItemEx(hItem,TVIF_NEXT|TVIF_PARAM,0,NULL,uCrc))
				{
				   pUser = (ListUserData*)m_cList.GetUserDataEx(hItem);
				if(pUser->uTurn                   ==m_uTurn                 )continue;
				if(pUser->pInfo->usRemotePort 	  !=pScan[uPos].usRemotePort)continue;
				if(pUser->pInfo->usLocalPort	  !=pScan[uPos].usLocalPort )continue;
				if(pUser->pInfo->ucType		  	  !=pScan[uPos].ucType	    )continue;
				if(strcmp(pUser->pInfo->cLocalAddr ,pScan[uPos].cLocalAddr ))continue;
				if(strcmp(pUser->pInfo->cRemoteAddr,pScan[uPos].cRemoteAddr))continue;

														// Hat sich der Zustand gendert
				if(pUser->pInfo->ucState!=pScan[uPos].ucState)
					{
					m_cList.SetItemTextEx     (hItem, NetStatState(pScan[uPos].ucState),5);
					m_cList.SetItemTextColorEx(hItem,-1,StateColor(pScan[uPos].ucState)  );
					uChanged |= 1<<5;
					}
														// Hat sich der Prozess verndert
				if(pUser->pInfo->uProcessId!=pScan[uPos].uProcessId)
					{
					if(*pScan[uPos].pProcessPath==0 && *pUser->pInfo->pProcessPath)
						{
						pPath = pUser->pInfo->pProcessPath;
						NetStatPath(pScan+uPos,pPath,pUser->pInfo->uProcessId);
						}
					else{
						itostr(pScan[uPos].uProcessId,cText);
						pName	= pScan[uPos].pProcessName;
						pPath	= pScan[uPos].pProcessPath;
						m_cList.SetItemTextEx(hItem,cText,6);
						m_cList.SetItemTextEx(hItem,pName,7);
						m_cList.SetItemTextEx(hItem,pPath,8);
						uChanged |= 7<<6;
						}
					}
														// Hat sich der Prozesspfad gendert
				if(strcmp(pUser->pInfo->pProcessPath,pScan[uPos].pProcessPath))
					{
					pName	= pScan[uPos].pProcessName;
					pPath	= pScan[uPos].pProcessPath;
					m_cList.SetItemTextEx(hItem,pName,7);
					m_cList.SetItemTextEx(hItem,pPath,8);
					uChanged |= 6<<6;
					}

				pUser->pInfo	= pScan+uPos;
				pUser->uTurn	= m_uTurn;
				pUser->uPos		= uPos;

				break;
				}

			if(hItem)continue;
			}

	
														// Einen neuen Eintrag einfgen
		sData.lParam		= 0;
		sData.pThis			= this;
		sData.sUser.pInfo	= pScan+uPos;
		sData.sUser.uTurn	= m_uTurn;
		sData.sUser.uPos	= uPos;

		hItem = m_cList.InsertItemEx(pTypes[pScan[uPos].ucType&3],CompareFunc,TVI_ROOT,(LPARAM)&sData);

		itostr(pScan[uPos].usLocalPort,cText);
		m_cList.SetItemTextEx(hItem,cText                   ,1);
		m_cList.SetItemTextEx(hItem,pScan[uPos].cLocalAddr  ,2);
		itostr(pScan[uPos].usRemotePort,cText);
		if(pScan[uPos].ucType&1)cText[0]=0;
		m_cList.SetItemTextEx(hItem,cText                   ,3);
		m_cList.SetItemTextEx(hItem,pScan[uPos].cRemoteAddr ,4);
		m_cList.SetItemTextEx(hItem,NetStatState(pScan[uPos].ucState),5);
		itostr(pScan[uPos].uProcessId,cText);
		m_cList.SetItemTextEx(hItem,cText                   ,6);
		m_cList.SetItemTextEx(hItem,pScan[uPos].pProcessName,7);
		m_cList.SetItemTextEx(hItem,pScan[uPos].pProcessPath,8);
		m_cList.SetItemTextColorEx(hItem,-1,StateColor(pScan[uPos].ucState));
		m_cList.SetItemDataEx(hItem,uCrc);

		pUser			= (ListUserData*)m_cList.GetUserDataEx(hItem);
		pUser->pInfo	= pScan+uPos;
		pUser->uTurn	= m_uTurn;
		pUser->uPos		= uPos;
		uChanged       |= 0x80000000;
		}


	hItem = m_cList.GetItemOfRowEx(0);
	hItem = m_cList.GetNextSiblingItemEx(hItem);


	while(hItem)										// Lsche Eintrge
		{
		pUser = (ListUserData*)m_cList.GetUserDataEx(hItem);

		if(pUser->uTurn==m_uTurn)
			{
			hItem = m_cList.GetNextSiblingItemEx(hItem);
			continue;
			}

		hNext = m_cList.GetNextSiblingItemEx(hItem);
		m_cList.DeleteItemEx(hItem);
		hItem = hNext;
		}

														// Muss das Fenster neu sortiert werden
	if(uChanged&((1<<m_aSortList[0])|(1<<m_aSortList[1])|(1<<m_aSortList[2])))
		{
		hItem	= m_cList.GetFocusItemEx();
		hNext	= m_cList.GetFirstNoneFixed();

		if(!hItem || !m_cList.IsItemVisibleEx(hItem))
			{
			hItem = hNext;
			}

		uItemRow	= m_cList.GetRowOfItemEx(hItem);
		uFirst		= m_cList.GetRowOfItemEx(hNext);

		Sort();											// Scrolle zum aktuellen Eintrag

		if(hItem && hNext && !m_cList.IsItemVisibleEx(hItem))
			{
			uItemRow -= uFirst;
			uFirst	  = m_cList.GetRowOfItemEx(hItem);
			
			m_cList.ListSetTopIndex(uFirst-uItemRow);
			}
		}


	if(m_pScan!=pScan)									// Alte Liste lschen
		{
		NetStatFree(m_pScan);
		m_pScan = pScan;
		}


}

//*****************************************************************************
//*
//*		OnDone
//*
//*****************************************************************************
//	Ein neue Scann vom Thread empfangen
LRESULT	CNetStatExView::OnDone(WPARAM wParam,LPARAM lParam)
{

	Scan((NetStatEntry*)lParam);
	SetTimer(ID_SCAN,5000,NULL);
	SetTimer(ID_TICK, 250,NULL);


return 0;
}

//*****************************************************************************
//*
//*		CompareFunc
//*
//*****************************************************************************
//	Vergleichsfunktion fr's Einfgen
int CALLBACK CNetStatExView::CompareFunc(HWND hWnd,HTREEITEM hItem,LPCTSTR pTextItem,LPCTSTR pTextInsert,LPARAM lParamItem,LPARAM lParamInsert)
{
CompareData	   *pData=(CompareData*)lParamInsert;
CNetStatExView *pThis=(CNetStatExView*)pData->pThis;
ListUserData   *pUser1;
ListUserData   *pUser2;
int				iTurn;
int				iCmp;


	pUser1	= &pData->sUser;
	pUser2	= (ListUserData*)pThis->m_cList.GetUserDataEx(hItem);

	if(!pUser1->pInfo)return -1;						// Ist der Eintrag der Filter
	if(!pUser2->pInfo)return  1;

	for(iTurn=0;iTurn<4;iTurn++)
		{
		switch(pThis->m_aSortList[iTurn])
			{
		case 0:	iCmp = 	pUser1->pInfo->ucType		-pUser2->pInfo->ucType;					break;
		case 1:	iCmp = 	pUser1->pInfo->usLocalPort	-pUser2->pInfo->usLocalPort;			break;
		case 2:	iCmp = 	strvicmp(pUser1->pInfo->cLocalAddr,pUser2->pInfo->cLocalAddr);		break;
		case 3:	iCmp = 	pUser1->pInfo->usRemotePort	-pUser2->pInfo->usRemotePort;			break;
		case 4:	iCmp = 	strvicmp(pUser1->pInfo->cRemoteAddr,pUser2->pInfo->cRemoteAddr);	break;
		case 5:	iCmp = 	pUser1->pInfo->ucState		-pUser2->pInfo->ucState;				break;
		case 6:	iCmp = 	pUser1->pInfo->uProcessId	-pUser2->pInfo->uProcessId;				break;
		case 7:	iCmp = 	strvicmp(pUser1->pInfo->pProcessName,pUser2->pInfo->pProcessName);	break;
		case 8:	iCmp = 	strvicmp(pUser1->pInfo->pProcessPath,pUser2->pInfo->pProcessPath);	break;
		default:iCmp = 	pUser1->pInfo-pUser2->pInfo;										break;
			}

		if(!iCmp)continue;

		if(pThis->m_iSortDir)iCmp=-iCmp;

		return iCmp;
		}


	   iCmp = pUser1->pInfo->usLocalPort-pUser2->pInfo->usLocalPort;
	if(iCmp)return iCmp;

	   iCmp = pUser1->pInfo->usRemotePort-pUser2->pInfo->usRemotePort;
	if(iCmp)return iCmp;

	   iCmp = pUser1->pInfo->uProcessId-pUser2->pInfo->uProcessId;
	if(iCmp)return iCmp;

	   iCmp = pUser1->pInfo->ucState-pUser2->pInfo->ucState;
	if(iCmp)return iCmp;



return	pData->lParam-lParamItem;
}

//*****************************************************************************
//*
//*		SortFunc
//*
//*****************************************************************************
int CALLBACK CNetStatExView::SortFunc(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
CNetStatExView *pThis=(CNetStatExView*)lParam;
ListUserData   *pUser1;
ListUserData   *pUser2;
int				iTurn;
int				iCmp;



	pUser1	= (ListUserData*)pThis->m_cList.GetUserDataEx(hItem1);
	pUser2	= (ListUserData*)pThis->m_cList.GetUserDataEx(hItem2);

	if(!pUser1->pInfo)return -1;						// Ist der Eintrag der Filter
	if(!pUser2->pInfo)return  1;

	for(iTurn=0;iTurn<4;iTurn++)
		{
		switch(pThis->m_aSortList[iTurn])
			{
		case 0:	iCmp = 	pUser1->pInfo->ucType		-pUser2->pInfo->ucType;					break;
		case 1:	iCmp = 	pUser1->pInfo->usLocalPort	-pUser2->pInfo->usLocalPort;			break;
		case 2:	iCmp = 	strvicmp(pUser1->pInfo->cLocalAddr  ,pUser2->pInfo->cLocalAddr);	break;
		case 3:	iCmp = 	pUser1->pInfo->usRemotePort	-pUser2->pInfo->usRemotePort;			break;
		case 4:	iCmp = 	strvicmp(pUser1->pInfo->cRemoteAddr ,pUser2->pInfo->cRemoteAddr);	break;
		case 5:	iCmp = 	pUser1->pInfo->ucState		-pUser2->pInfo->ucState;				break;
		case 6:	iCmp = 	pUser1->pInfo->uProcessId	-pUser2->pInfo->uProcessId;				break;
		case 7:	iCmp = 	strvicmp(pUser1->pInfo->pProcessName,pUser2->pInfo->pProcessName);	break;
		case 8:	iCmp = 	strvicmp(pUser1->pInfo->pProcessPath,pUser2->pInfo->pProcessPath);	break;
		default:iCmp = 	pUser1->pInfo-pUser2->pInfo;										break;
			}

		if(!iCmp)continue;

		if(pThis->m_iSortDir)iCmp=-iCmp;

		return iCmp;
		}


return	lParam1-lParam2;
}

//*****************************************************************************
//*
//*		OnListSort
//*
//*****************************************************************************
void CNetStatExView::OnListSort(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHEADER	   *pHeader = (NMHEADER*)pNmHdr;
TVSORTEX		sSort;


	*pResult = 0;

	if(pHeader->iItem==m_aSortList[0])
		{
		m_iSortDir		=!m_iSortDir;
		}
	else{
		m_aSortList[2]	= m_aSortList[1];
		m_aSortList[1]	= m_aSortList[0];
		m_aSortList[0]	= pHeader->iItem;
		}


	m_iSortOn			= 1;
	sSort.lpfnCompare	= SortFunc;
	sSort.hParent		= TVI_ROOT;
	sSort.lParam		= (LPARAM)this;
	m_cList.SortChildrenEX(&sSort);
	m_iSortOn			= 0;

}

//*****************************************************************************
//*
//*		OnEditPaste
//*
//*****************************************************************************
void CNetStatExView::OnEditPaste()
{

	if(m_iDoEdit)
		{
		m_cList.PostMessage(WM_PASTE);
		}


}

//*****************************************************************************
//*
//*		OnEditCopy
//*
//*****************************************************************************
void CNetStatExView::OnEditCopy()
{


	if(m_iDoEdit)
		{
		m_cList.PostMessage(WM_COPY);
		}

}

//*****************************************************************************
//*
//*		OnEditCut
//*
//*****************************************************************************
void CNetStatExView::OnEditCut()
{

	if(m_iDoEdit)
		{
		m_cList.PostMessage(WM_CUT);
		}

}

//*****************************************************************************
//*
//*		OnListStartEdit
//*
//*****************************************************************************
//	ndern eines Eintrages mit Return
void CNetStatExView::OnListStartEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
static char		cTemp[16*128];
TV_STARTEDIT   *pData=(TV_STARTEDIT*)pNmHdr;
ListUserData   *pUser;
HTREEITEM		hItem;
LPTSTR			pText;
int				iSub;
int				iLen;
int				iPos;


	hItem = pData->item.hItem;
	iSub  = pData->item.cChildren;
	pUser = (ListUserData*)m_cList.GetUserDataEx(hItem);

	if(!pUser || pUser->pInfo)								// Nur Filter bearbeiten
		{
		*pResult = 0;
		return;
		}

	if(iSub==0)												// Art des Sockets
		{
		pData->uMaxEntries  = 7;
		pData->pTextEntries	= "All\0Tcp\0Udp\0Tcp V4\0Udp V4\0Tcp V6\0Udp V6";
		*pResult  = TVIR_EDITCOMBOBOX|TVIR_EDITCOMBOLIST|TVIR_EDITCOMBODOWN|TVIR_EDITFULL;
		m_iDoEdit = 2;
		return;
		}

	if(iSub==5)												// SocketZustand
		{
		iLen = strlcpy(cTemp,"All",sizeof(cTemp))+1;

		for(iPos=0;iPos<=12;iPos++)
			{
			iLen += strlcpy(cTemp+iLen,NetStatState(iPos),sizeof(cTemp)-iLen)+1;
			}

		pData->uMaxEntries  = 13;
		pData->pTextEntries	= cTemp;
		*pResult  = TVIR_EDITCOMBOBOX|TVIR_EDITCOMBOLIST|TVIR_EDITCOMBODOWN|TVIR_EDITFULL;
		m_iDoEdit = 2;
		return;
		}


	m_iDoEdit = 1;

	iLen = m_aLastFilters[iSub].Chain(&pText);

	if(iLen>sizeof(cTemp))
		{
		memcpy(cTemp,pText,sizeof(cTemp));
		cTemp[sizeof(cTemp)-1]=0;
		cTemp[sizeof(cTemp)-2]=0;
		}
	else{
		memcpy(cTemp,pText,iLen);
		}

	delete pText;

	m_sLastFieldText	= pData->item.pszText;
	pData->uMaxEntries  = m_aLastFilters[iSub].Count();
	pData->pTextEntries	= cTemp;

	*pResult  = TVIR_EDITCOMBOBOX|TVIR_EDITCOMBODOWN|TVIR_EDITFULL;

}

//*****************************************************************************
//*
//*		OnListEndEdit
//*
//*****************************************************************************
void CNetStatExView::OnListEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pItem=(NMTVDISPINFO*)pNmHdr;
int				aValue[9];
int				aArray[8];
int				iFlag;
int				iSub;
int				iNum;
int				iPos;


	m_iDoEdit = 0;

	if(!(pItem->item.mask&TVIF_TEXTCHANGED))			// Hat sich der Text verndert
		{
		*pResult = 0;
		return;
		}

	iSub	= pItem->item.cChildren;

	if(iSub==0)											// Art des Sockets
		{
		if(m_uFilter!=0x0F && !stricmp(pItem->item.pszText,"All"   )){m_uFilter=0x0F;m_bNewFlag=1;}
		if(m_uFilter!=0x05 && !stricmp(pItem->item.pszText,"Tcp"   )){m_uFilter=0x05;m_bNewFlag=1;}
		if(m_uFilter!=0x0A && !stricmp(pItem->item.pszText,"Udp"   )){m_uFilter=0x0A;m_bNewFlag=1;}
		if(m_uFilter!=0x01 && !stricmp(pItem->item.pszText,"Tcp V4")){m_uFilter=0x01;m_bNewFlag=1;}
		if(m_uFilter!=0x02 && !stricmp(pItem->item.pszText,"Udp V4")){m_uFilter=0x02;m_bNewFlag=1;}
		if(m_uFilter!=0x04 && !stricmp(pItem->item.pszText,"Tcp V6")){m_uFilter=0x04;m_bNewFlag=1;}
		if(m_uFilter!=0x08 && !stricmp(pItem->item.pszText,"Udp V6")){m_uFilter=0x08;m_bNewFlag=1;}
		}

	if(iSub==1)											// Lokales Port
		{
		iNum = strgetlist(pItem->item.pszText,aArray,8,STR_GL_INT|STR_GL_FILL|STR_GL_NEG);

		for(iPos=0;iPos<iNum;iPos++)
			{
			   aValue[iPos] = 0;
			if(aArray[iPos]>= 0)continue;
			   aValue[iPos] = 1;
			   aArray[iPos] =-aArray[iPos];
			}

		if(iNum<8)
			{
			aValue[iNum] = -1;
			iNum++;
			}

		if(memcmp(m_aFilterLocPort,aArray,sizeof(int)*iNum) || memcmp(m_aFilterLocDual,aValue,sizeof(int)*iNum))
			{
			memcpy(m_aFilterLocPort,aArray,sizeof(int)*iNum);
			memcpy(m_aFilterLocDual,aValue,sizeof(int)*iNum);
			m_bNewFlag=1;
			iFlag=1;
			}
		}

	if(iSub==2)											// Lokale Adresse
		{
		if(strcmp(m_aFilterLocAddr,pItem->item.pszText))
			{
			strlcpy(m_aFilterLocAddr,pItem->item.pszText,sizeof(m_aFilterLocAddr));
			m_bNewFlag=1;
			iFlag=1;
			}
		}

	if(iSub==3)											// Remote-Port
		{
		iNum = strgetlist(pItem->item.pszText,aArray,8,STR_GL_INT|STR_GL_FILL|STR_GL_NEG);

		for(iPos=0;iPos<iNum;iPos++)
			{
			   aValue[iPos] = 0;
			if(aArray[iPos]>= 0)continue;
			   aValue[iPos] = 1;
			   aArray[iPos] =-aArray[iPos];
			}

		if(iNum<8)
			{
			aValue[iNum] = -1;
			iNum++;
			}

		if(memcmp(m_aFilterRemPort,aArray,sizeof(int)*iNum) || memcmp(m_aFilterRemDual,aValue,sizeof(int)*iNum))
			{
			memcpy(m_aFilterRemPort,aArray,sizeof(int)*iNum);
			memcpy(m_aFilterRemDual,aValue,sizeof(int)*iNum);
			m_bNewFlag=1;
			iFlag=1;
			}
		}

	if(iSub==4)											// Remote-Adresse
		{
		if(strcmp(m_aFilterRemAddr,pItem->item.pszText))
			{
			strlcpy(m_aFilterRemAddr,pItem->item.pszText,sizeof(m_aFilterLocAddr));
			m_bNewFlag=1;
			iFlag=1;
			}
		}

	if(iSub==5)											// Socket-Zuustand
		{
		for(iNum=12;iNum>=0;iNum--)
			{
			if(!stricmp(pItem->item.pszText,NetStatState(iNum)))break;
			}

		if(m_uFilterState!=(UINT)iNum+1)
			{
			m_uFilterState = iNum+1;
			m_bNewFlag=1;
			iFlag=1;
			}
		}

	if(iSub==6)											// Prozess-ID
		{
		iNum = strgetlist(pItem->item.pszText,aArray,8,STR_GL_INT|STR_GL_FILL);

		if(iNum<8)iNum++;

		if(memcmp(m_aFilterProcess,aArray,sizeof(int)*iNum))
			{
			memcpy(m_aFilterProcess,aArray,sizeof(int)*iNum);
			m_bNewFlag=1;
			iFlag=1;
			}
		}

	if(iSub==7)											// Programmname
		{
		if(strcmp(m_aFilterName,pItem->item.pszText))
			{
			strlcpy(m_aFilterName,pItem->item.pszText,sizeof(m_aFilterName));
			m_bNewFlag=1;
			iFlag=1;
			}
		}

	if(iSub==8)											// Programmpfad
		{
		if(strcmp(m_aFilterPath,pItem->item.pszText))
			{
			strlcpy(m_aFilterPath,pItem->item.pszText,sizeof(m_aFilterPath));
			m_bNewFlag=1;
			iFlag=1;
			}
		}


	if(iFlag && !m_sLastFieldText.IsEmpty())			// Letze Eingaben speichern
		{
		m_aLastFilters[iSub].CAdd(m_sLastFieldText);
		m_sLastFieldText.Empty();
		}

	*pResult = 0;


}

//*****************************************************************************
//*
//*		OnClearFilter
//*
//*****************************************************************************
void CNetStatExView::OnClearFilter()
{
HTREEITEM	hItem;


	hItem = m_cList.GetFirstItem();

	if(m_uFilter!=0x0F)
		{
		m_cList.SetItemText(hItem,"All");
		m_uFilter  = 0x0F;
		m_bNewFlag = 1;
		}

	if(m_aFilterLocPort[0]!=-1)
		{
		m_cList.SetItemText(hItem,"",1);
		m_aFilterLocPort[0] = -1;
		m_bNewFlag = 1;
		}

	if(m_aFilterLocAddr[0])
		{
		m_cList.SetItemText(hItem,"",2);
		m_aFilterLocAddr[0] = 0;
		m_bNewFlag = 1;
		}

	if(m_aFilterRemPort[0]!=-1)
		{
		m_cList.SetItemText(hItem,"",3);
		m_aFilterRemPort[0] = -1;
		m_bNewFlag = 1;
		}

	if(m_aFilterRemAddr[0])
		{
		m_cList.SetItemText(hItem,"",4);
		m_aFilterRemAddr[0] = 0;
		m_bNewFlag = 1;
		}

	if(m_uFilterState!=0)
		{
		m_cList.SetItemText(hItem,"All",5);
		m_uFilterState  = 0;
		m_bNewFlag = 1;
		}

	if(m_aFilterProcess[0]!=-1)
		{
		m_cList.SetItemText(hItem,"",6);
		m_aFilterProcess[0] = -1;
		m_bNewFlag = 1;
		}

	if(m_aFilterName[0])
		{
		m_cList.SetItemText(hItem,"",7);
		m_aFilterName[0] = 0;
		m_bNewFlag = 1;
		}

	if(m_aFilterPath[0])
		{
		m_cList.SetItemText(hItem,"",8);
		m_aFilterPath[0] = 0;
		m_bNewFlag = 1;
		}

}

//*****************************************************************************
//*
//*		OnAutoUpdate
//*
//*****************************************************************************
void CNetStatExView::OnAutoUpdate()
{

	m_bAutoUpdate = !m_bAutoUpdate;

}

//*****************************************************************************
//*
//*		OnAutoUpdateUI
//*
//*****************************************************************************
void CNetStatExView::OnAutoUpdateUI(CCmdUI *pCmdUI)
{

	pCmdUI->SetCheck(m_bAutoUpdate);

}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CNetStatExView::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
HTREEITEM	hFirst;
HTREEITEM	hItem;
CMenu		sMenu;
int			iFlag;
int			iNotF;
int			iDual;
int			iText;
int			iCol;


	if(!pWnd)return;

	iCol	= m_cList.GetFocusColumn();
	hItem	= m_cList.GetFocusItem();
	hFirst  = m_cList.GetFirstItem();
	iFlag   = (hItem==hFirst)? MF_GRAYED:0;
	iNotF   = (hItem!=hFirst)? MF_GRAYED:0;
	iDual   = (hItem!=hFirst && (iCol==1 || iCol==3))? 0:MF_GRAYED;
	iText   = (IsClipboardFormatAvailable(CF_TEXT) && iFlag)? 0:MF_GRAYED;

	sMenu.CreatePopupMenu();
	sMenu.AppendMenu(MF_STRING      ,ID_COPYITEM ,"Feld kopieren");
	sMenu.AppendMenu(MF_STRING|iText,ID_PASTEITEM,"Text einfgen");
	sMenu.AppendMenu(MF_STRING|iFlag,ID_SETFILTER,"Als Filter setzen");
	sMenu.AppendMenu(MF_STRING|iDual,ID_SETDUALFL,"Dual-Filter setzen");
	sMenu.AppendMenu(MF_STRING|iNotF,ID_DELFILTER,"Filter lschen");

	AddMenuBitmap(sMenu,ID_COPYITEM    ,IDB_TOOLICONS, 1);
	AddMenuBitmap(sMenu,ID_PASTEITEM   ,IDB_TOOLICONS, 2);
	AddMenuBitmap(sMenu,ID_SETFILTER   ,IDB_TOOLICONS, 4);
	AddMenuBitmap(sMenu,ID_DELFILTER   ,IDB_TOOLICONS, 3);


	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();


}

//*****************************************************************************
//*
//*		OnCopyItem
//*
//*****************************************************************************
void CNetStatExView::OnCopyItem()
{
HTREEITEM	hItem;
int			iCol;

		hItem	= m_cList.GetFocusItem();
	if(!hItem)return;

	iCol = m_cList.GetFocusColumn();

	SetClipboardText(m_cList.GetItemText(hItem,iCol));

}

//*****************************************************************************
//*
//*		OnPasteItem
//*
//*****************************************************************************
void CNetStatExView::OnPasteItem()
{
char			cText[256];
NMTVDISPINFO	sInfo;
HTREEITEM		hItem;
LRESULT			iRet;
int				iCol;


		hItem	= m_cList.GetFocusItem();
	if(!hItem || m_cList.GetRowOfItem(hItem))return;

	iCol = m_cList.GetFocusColumn();

	if(GetClipboardText(cText,sizeof(cText))<=0)return;

	m_cList.SetItemText(hItem,cText,iCol);

	sInfo.item.hItem		= hItem;
	sInfo.item.pszText		= cText;
	sInfo.item.cChildren	= iCol;
	sInfo.item.mask			= TVIF_TEXTCHANGED;

	OnListEndEdit(&sInfo.hdr,&iRet);

}


//*****************************************************************************
//*
//*		OnSetFilter
//*
//*****************************************************************************
void CNetStatExView::OnSetFilter()
{
char			cText[256];
NMTVDISPINFO	sInfo;
HTREEITEM		hItem;
LRESULT			iRet;
int				iCol;


		hItem	= m_cList.GetFocusItem();
	if(!hItem)return;

	iCol = m_cList.GetFocusColumn();

	m_cList.GetItemText(hItem,cText,sizeof(cText),iCol);
	sInfo.item.hItem		= hItem;
	sInfo.item.pszText		= cText;
	sInfo.item.cChildren	= iCol;
	sInfo.item.mask			= TVIF_TEXTCHANGED;

	hItem = m_cList.GetFirstItem();
	m_cList.SetItemText(hItem,cText,iCol);
	OnListEndEdit(&sInfo.hdr,&iRet);

}

//*****************************************************************************
//*
//*		OnSetDualFl
//*
//*****************************************************************************
void CNetStatExView::OnSetDualFl()
{
char			cText[256];
NMTVDISPINFO	sInfo;
HTREEITEM		hItem;
LRESULT			iRet;
int				iCol;


		hItem	= m_cList.GetFocusItem();
	if(!hItem)return;

	iCol = m_cList.GetFocusColumn();

	if(iCol!=1 && iCol!=3)return;


	m_cList.GetItemText(hItem,cText+1,sizeof(cText)-1,iCol);
	sInfo.item.hItem		= hItem;
	sInfo.item.pszText		= cText;
	sInfo.item.cChildren	= iCol;
	sInfo.item.mask			= TVIF_TEXTCHANGED;
	cText[0]				= '-';

	if(atoi(cText+1)==0)return;

	hItem = m_cList.GetFirstItem();
	m_cList.SetItemText(hItem,cText,iCol);
	OnListEndEdit(&sInfo.hdr,&iRet);

}


//*****************************************************************************
//*
//*		OnDelFilter
//*
//*****************************************************************************
void CNetStatExView::OnDelFilter()
{
char			cText[256];
NMTVDISPINFO	sInfo;
HTREEITEM		hItem;
LRESULT			iRet;
int				iCol;


		hItem	= m_cList.GetFocusItem();
	if(!hItem)return;

	iCol  = m_cList.GetFocusColumn();
	if(iCol==0 || iCol==5)
		{
		strcpy(cText,"All");
		}
	else{
		cText[0] = 0;
		}

	sInfo.item.hItem		= hItem;
	sInfo.item.pszText		= cText;
	sInfo.item.cChildren	= iCol;
	sInfo.item.mask			= TVIF_TEXTCHANGED;

	hItem = m_cList.GetFirstItem();
	m_cList.SetItemText(hItem,cText,iCol);
	OnListEndEdit(&sInfo.hdr,&iRet);

}

//*****************************************************************************
//*
//*		SaveDocument
//*
//*****************************************************************************
BOOL CNetStatExView::SaveDocument(LPCTSTR pPathName)
{
HTREEITEM		hItem;
FILE		   *pFile;
int				iPos;

		hItem = m_cList.GetFirstItem();
	if(!hItem)return FALSE;

		pFile = fopen(pPathName,"wb");
	if(!pFile)return FALSE;


	for(;;)
		{
			hItem = m_cList.GetNextSiblingItem(hItem);
		if(!hItem)break;

		for(iPos=0;iPos<=8;iPos++)
			{
			fprintf(pFile,"%s;",m_cList.GetItemText(hItem,iPos));
			}

		fprintf(pFile,"\n");
		}


	fclose(pFile);



return TRUE;
}

//*****************************************************************************
//*
//*		ScanThread
//*
//*****************************************************************************
//	Thread fr's scannen
DWORD WINAPI  CNetStatExView::ScanThread(LPVOID pParam)
{
CNetStatExView *pView=(CNetStatExView*)pParam;
NetStatEntry   *pScan;



		pScan = NetStatGet(0x1000F);
	if(!pScan)
		{
		m_iScanRun = 0;
		return 0;
		}

	if(!pView->PostMessage(ID_DONE,0,(LPARAM)pScan))
		{
		Sleep(50);

		if(!pView->PostMessage(ID_DONE,0,(LPARAM)pScan))
			{
			Sleep(50);
			if(!pView->PostMessage(ID_DONE,0,(LPARAM)pScan))
				{
				NetStatFree(pScan);
				}
			}
		}


	m_iScanRun = 0;

return 0;
}

//*****************************************************************************
//*
//*		Delete
//*
//*****************************************************************************
//	Lscht die aktuellen Daten
int CNetStatExView::Delete(int iMode)
{
NetStatEntry   *pLast;
HTREEITEM		hItem;



	hItem = m_cList.GetItemOfRow(1);

	if(iMode && hItem)
		{
		return 0;
		}

	while(hItem)
		{
		m_cList.DeleteItem(hItem);
		hItem = m_cList.GetItemOfRow(1);
		}

	if(m_pScan)
		{
		pLast   = m_pScan;
		m_pScan = 0;
		NetStatFree(pLast);
		}


return 0;
}

//*****************************************************************************
//*
//*		CalcCrc
//*
//*****************************************************************************
//	Berechnet eine CRC fr einen Eintrag
DWORD CNetStatExView::CalcCrc(const NetStatEntry *pScan)
{
DWORD	uCrc;


	uCrc	= pScan->usLocalPort;
	uCrc   |= pScan->usRemotePort<<16;
	uCrc   ^= pScan->ucType<<12;
	uCrc   ^= Crc32Calc(pScan->cLocalAddr ,strlen(pScan->cLocalAddr ));
	uCrc   ^= Crc32Calc(pScan->cRemoteAddr,strlen(pScan->cRemoteAddr));


return uCrc;
}