//*****************************************************************************
//*
//*
//*		NetStatExView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_NETSTATEXVIEW_H__1671DFE5_7F4F_4409_82FA_1CB8460109C3__INCLUDED_
#define		AFX_NETSTATEXVIEW_H__1671DFE5_7F4F_4409_82FA_1CB8460109C3__INCLUDED_	

#include	"NetStatLib.h"


#if _MSC_VER > 1000
#pragma		once						
#endif


//*****************************************************************************
//*
//*		Klasse CNetStatExView
//*
//*****************************************************************************
class CNetStatExView : public CView
{
protected:

	CNetStatExView();
	DECLARE_DYNCREATE(CNetStatExView)

public:

	CNetStatExDoc* GetDocument();
	BOOL	SaveDocument(LPCTSTR pPathName);
	int		Delete(int iMode);

	//{{AFX_VIRTUAL(CNetStatExView)
public:
	virtual void OnDraw(CDC* pDC);								// overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT &sCreate);
protected:
	//}}AFX_VIRTUAL

public:
	virtual ~CNetStatExView();
	#ifdef		_DEBUG					
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
	#endif

protected:

	typedef struct
		{
		NetStatEntry   *pInfo;
		unsigned		uTurn;		
		unsigned		uPos;		
		}ListUserData;

	typedef struct
		{
		void		   *pThis;
		ListUserData	sUser;	
		LPARAM			lParam;
		}CompareData;

	CTreeListCtrlEx	m_cList;
	int				m_aFilterProcess[8];
	int				m_aFilterLocDual[8];
	int				m_aFilterRemDual[8];
	int				m_aFilterLocPort[8];
	int				m_aFilterRemPort[8];
	char			m_aFilterLocAddr[8*64];
	char			m_aFilterRemAddr[8*64];
	char			m_aFilterName   [8*64];
	char			m_aFilterPath   [8*64];
	CStringChain	m_aLastFilters  [9];
	CString			m_sLastFieldText;
	unsigned		m_uFilterState;
	unsigned		m_uFilter;
	unsigned		m_uTurn;
	NetStatEntry   *m_pScan;
	BOOL			m_bNewFlag;
	BOOL			m_bAutoUpdate;
	BYTE			m_aSortList[4];
	int				m_iSortDir;
	int				m_iDoEdit;
	int				m_iSortOn;
	static int		m_iScanRun;  	


	//{{AFX_MSG(CNetStatExView)
	afx_msg int  OnCreate(LPCREATESTRUCT pCreateStruct);
	afx_msg void OnSize(UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnContextMenu(CWnd *pWnd,CPoint sPoint);
	afx_msg void OnAutoUpdateUI(CCmdUI *pCmdUI);
	afx_msg void OnTimer(UINT_PTR nIdEvent);
	afx_msg void OnClearFilter();
	afx_msg void OnAutoUpdate();
	afx_msg void OnEditPaste();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnCopyItem();
	afx_msg void OnPasteItem();
	afx_msg void OnSetDualFl();
	afx_msg void OnSetFilter();
	afx_msg void OnDelFilter();
	//}}AFX_MSG

	afx_msg void	OnListSort       (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void	OnListEndEdit    (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void	OnListStartEdit  (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg LRESULT	OnDone           (WPARAM wParam,LPARAM lParam);
	
	static  int  CALLBACK SortFunc   (HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam);
	static  int  CALLBACK CompareFunc(HWND hWnd,HTREEITEM hItem,LPCTSTR pTextItem,LPCTSTR pTextInsert,LPARAM lParamItem,LPARAM lParamInsert);
	static  DWORD WINAPI  ScanThread (LPVOID pParam);
	static  DWORD		  CalcCrc    (const NetStatEntry *pScan);

	DECLARE_MESSAGE_MAP()

	void Sort();
	void Scan(NetStatEntry *pScan);	
	COLORREF	StateColor(unsigned uState);	

};

#ifndef		_DEBUG												// debug version in NetStatExView.cpp

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
inline CNetStatExDoc *CNetStatExView::GetDocument()
{

return (CNetStatExDoc*)m_pDocument; 
}
#endif


//{{AFX_INSERT_LOCATION}}

#endif
