//*****************************************************************************
//*
//*
//*		NetStatLib.cpp
//*
//*
//*****************************************************************************
//
//	Source-Code Beispiel:
//
//		NetStatEntry	*pList;
//		unsigned		 uPos;
//
//			pList = NetStatGet();
//		if(!pList)return;
//
//		for(uPos=0;;uPos++)
//			{
//			if(pList[uPos].ucType==0xFF)break;
//
//			printf("%s:%i -> %s:%i = %s\n",
//						pList[uPos].cLocalAddr ,pList[uPos].usLocalPort ,
//						pList[uPos].cRemoteAddr,pList[uPos].usRemotePort,
//						NetStatState(pList[uPos].ucState));
//			}
//
//		NetStatFree(pList);
//
#include	<windows.h>
#include	<tlhelp32.h>
#include	<string.h>
#include	<stdlib.h>
#include	<stdio.h>

#include	"NetStatLib.h"

#define		TCP_TABLE_OWNER_PID_ALL		5
#define 	UDP_TABLE_OWNER_PID			1
#ifndef 	AF_INET6
#define 	AF_INET6					23
#endif
#define 	BETOLE(a)					((WORD)(((a)<<8) | ((WORD)(a)>>8)))

typedef struct
	{
	DWORD			dwState;
	DWORD			dwLocalAddr;
	DWORD			dwLocalPort;
	DWORD			dwRemoteAddr;
	DWORD			dwRemotePort;
	}MIB_TCPROW,*PMIB_TCPROW;

typedef struct
	{
	DWORD			dwState;
	DWORD			dwLocalAddr;
	DWORD			dwLocalPort;
	DWORD			dwRemoteAddr;
	DWORD			dwRemotePort;
	DWORD       	dwOwningPid;
	}MIB_TCPROW_EX,MIB_TCPROW_OWNER_PID,*PMIB_TCPROW_OWNER_PID;

typedef struct
	{
	DWORD			dwState;
	DWORD			dwLocalAddr;
	DWORD			dwLocalPort;
	DWORD			dwRemoteAddr;
	DWORD			dwRemotePort;
	DWORD       	dwOwningPid;
	DWORD			dwOffloadState;
	}MIB_TCPROW2,*PMIB_TCPROW2;

typedef struct _MIB_UDP6ROW_OWNER_PID
	{
	UCHAR			ucLocalAddr[16];
	DWORD			dwLocalScopeId;
	DWORD			dwLocalPort;
	DWORD			dwOwningPid;
	}MIB_UDP6ROW_EX,MIB_UDP6ROW_OWNER_PID,*PMIB_UDP6ROW_OWNER_PID;

typedef struct _MIB_TCP6ROW_OWNER_PID
	{
	UCHAR			ucLocalAddr[16];
	DWORD			dwLocalScopeId;
	DWORD			dwLocalPort;
	UCHAR			ucRemoteAddr[16];
	DWORD			dwRemoteScopeId;
	DWORD			dwRemotePort;
	DWORD			dwState;
	DWORD			dwOwningPid;
	}MIB_TCP6ROW_EX,MIB_TCP6ROW_OWNER_PID,*PMIB_TCP6ROW_OWNER_PID;

typedef struct
	{
	DWORD			dwLocalAddr;
	DWORD			dwLocalPort;
	}MIB_UDPROW, *PMIB_UDPROW;

typedef struct
	{
	DWORD			dwLocalAddr;
	DWORD			dwLocalPort;
	DWORD       	dwOwningPid;
	}MIB_UDPROW_EX,MIB_UDPROW_OWNER_PID,*PMIB_UDPROW_OWNER_PID;

typedef struct
	{
	DWORD			dwNumEntries;
	MIB_TCPROW		table[1];
	}MIB_TCPTABLE,*PMIB_TCPTABLE;

typedef struct
	{
	DWORD			dwNumEntries;
	MIB_TCPROW_EX	table[1];
	}MIB_TCPTABLE_OWNER_PID,*PMIB_TCPTABLE_OWNER_PID;

typedef struct
	{
	DWORD			dwNumEntries;
	MIB_TCPROW2		table[1];
	}MIB_TCPTABLE2,*PMIB_TCPTABLE2;

typedef struct _MIB_UDPTABLE
	{
	DWORD			dwNumEntries;
	MIB_UDPROW		table[1];
	}MIB_UDPTABLE,*PMIB_UDPTABLE;

typedef struct
	{
	DWORD			dwNumEntries;
	MIB_UDPROW_EX	table[1];
	}MIB_UDPTABLE_OWNER_PID,*PMIB_UDPTABLE_OWNER_PID;

typedef struct
	{
	DWORD           dwNumEntries;
	MIB_UDP6ROW_EX	table[1];
	}MIB_UDP6TABLE_OWNER_PID, *PMIB_UDP6TABLE_OWNER_PID;

typedef struct _MIB_TCP6TABLE_OWNER_PID
	{
	DWORD           dwNumEntries;
	MIB_TCP6ROW_EX	table[1];
	}MIB_TCP6TABLE_OWNER_PID,*PMIB_TCP6TABLE_OWNER_PID;


typedef DWORD (WINAPI *GetTcpTableType        )(PMIB_TCPTABLE   pTcpTable,PDWORD pSize,BOOL bOrder);
typedef DWORD (WINAPI *GetUdpTableType        )(PMIB_UDPTABLE   pUdpTable,PDWORD pSize,BOOL bOrder);
typedef DWORD (WINAPI *GetExtendedTcpTableType)(PVOID           pUdpTable,PDWORD pSize,BOOL bOrder,ULONG ulAf,DWORD dwTableClass,ULONG ulReserved);
typedef DWORD (WINAPI *GetExtendedUdpTableType)(PVOID           pUdpTable,PDWORD pSize,BOOL bOrder,ULONG ulAf,DWORD dwTableClass,ULONG ulReserved);


static HMODULE	hApiDll=0;


#ifndef	TH32CS_SNAPMODULE32
#define	TH32CS_SNAPMODULE32					0x00000010
#endif

#ifndef	PROCESS_QUERY_LIMITED_INFORMATION
#define	PROCESS_QUERY_LIMITED_INFORMATION	0x00001000
#endif


//*****************************************************************************
//*
//*		GetSystemPid
//*
//*****************************************************************************
static DWORD GetSystemPid()
{
static DWORD	uDoneId=0xFFFFFFFF;
HANDLE			hSnapshot;
PROCESSENTRY32	sEntry;
DWORD			uPid;


	if(uDoneId!=0xFFFFFFFF)
		{
		return uDoneId;
		}

    hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

	memset(&sEntry,0,sizeof(sEntry));
    sEntry.dwSize  = sizeof(sEntry);


    if(!Process32First(hSnapshot,&sEntry))						// Walkthrough all processes.
		{
		uDoneId = 0;
		return 0;
		}

    for(;;)
        {
		uPid = sEntry.th32ProcessID;

		if(!Process32Next(hSnapshot,&sEntry))
			{
			uPid=0;
			break;
			}

		if(stricmp(sEntry.szExeFile,"System"))
			{
			break;
			}
		}

    CloseHandle(hSnapshot);
	uDoneId = uPid;


return uPid;
}

//*****************************************************************************
//*
//*		ProcessFileName
//*
//*****************************************************************************
static DWORD WINAPI ProcessFileName(unsigned uId,LPTSTR pFilename,int iSize)
{
typedef BOOL  (_stdcall *QueryFullProcessImageNameType)(HANDLE,DWORD,LPTSTR,LPDWORD);
typedef DWORD (_stdcall *GetModuleFileNameExType      )(HANDLE,HMODULE,LPTSTR,DWORD);
static GetModuleFileNameExType			pGetN=0;
static QueryFullProcessImageNameType	pProc=0;
static BOOL								bDone=0;
static HANDLE							hToken=0;
TOKEN_PRIVILEGES						sTokenPriv;
LUID									sLuidDebug;
DWORD									dwByte;
HMODULE									hExe;
HMODULE									hDll;



	if(iSize<=0)return 0;

	if(!pProc && !bDone)
		{
		bDone = 1;

		   hDll = GetModuleHandle("KERNEL32");
		if(hDll)
			{											// Exist only on Vista and higher
			pProc = (QueryFullProcessImageNameType)GetProcAddress(hDll,"QueryFullProcessImageNameA");
			}

		   hDll = GetModuleHandle("Psapi.dll");
		if(hDll)
			{											// Exist only on Vista and higher
			pGetN = (GetModuleFileNameExType)GetProcAddress(hDll,"GetModuleFileNameExA");
			}
		}


	if(!hToken)											// Set Debug-Privilege
		{
		if(OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES,&hToken))
			{
			if(LookupPrivilegeValue(NULL,SE_DEBUG_NAME,&sLuidDebug)!=FALSE)
				{
				sTokenPriv.PrivilegeCount           = 1;
				sTokenPriv.Privileges[0].Luid       = sLuidDebug;
				sTokenPriv.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
				AdjustTokenPrivileges(hToken, FALSE,&sTokenPriv,0,NULL,NULL);
				}

			CloseHandle(hToken);
			}
		}


		hExe = (HMODULE)OpenProcess(PROCESS_QUERY_INFORMATION,FALSE,uId);
	if(!hExe)
		{
			hExe = (HMODULE)OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION,FALSE,uId);
		if(!hExe)
			{
			if(uId==GetSystemPid() && iSize>6)
				{
				strcpy(pFilename,"System");
				return 6;
				}
	
			return 0;
			}
		}


	dwByte = iSize;
	iSize  = 0;

	if(pProc && pProc(hExe,0,pFilename,&dwByte))
		{
		iSize =  dwByte;
		}
	else if(pGetN)
		{
		iSize =  pGetN(hExe,0,pFilename,dwByte);
		if(iSize<=0)pFilename[0]=0;
		}
	else{
		pFilename[0] = 0;
		}


	CloseHandle(hExe);


return iSize;
}

//*****************************************************************************
//*
//*		ProcessPathFormId
//*
//*****************************************************************************
//	Gets the path of the exe file from a sEntry id.
//	uId	: is the sEntry id
//	pPath	: here the path of the sEntry is stored (without the *.exe suffix)
//	iSize	: size of the path pBuffer in bytes
//	Returns the size of the path or 0 if an error occurs
static int ProcessPathFormId(unsigned uId,char *pPath,int iSize)
{
HANDLE			hModules;
MODULEENTRY32	sModule;
int				iLen;


	if(iSize<=0)return 0;
	if(uId  ==0)return 0;


	if(!ProcessFileName(uId,sModule.szExePath,sizeof(sModule.szExePath)))
		{
		hModules       = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE|TH32CS_SNAPMODULE32,uId);
		sModule.dwSize = sizeof(sModule);

		if(!hModules || hModules==INVALID_HANDLE_VALUE)
			{
			if(uId==GetSystemPid() && iSize>6)
				{
				strcpy(pPath,"System");
				return 6;
				}

			pPath[0] = 0;
			return 0;
			}

		if(!Module32First(hModules,&sModule))
			{
			CloseHandle(hModules);
			pPath[0] = 0;
			return 0;
			}

		CloseHandle(hModules);
		}


	if(!strnicmp(sModule.szExePath,"\\SystemRoot\\",12))
		{
		iLen=GetWindowsDirectory(pPath,iSize);

		if(!iLen || iLen+2>=iSize)
			{
			pPath[0] = 0;
			return 0;
			}

		strncpy(pPath+iLen,sModule.szExePath+11,iSize-iLen);
		pPath[iSize-1]=0;

		iLen=strlen(pPath);

		return iLen;
		}


	if(sModule.szExePath[0]=='\\' &&
	   sModule.szExePath[1]=='?'  &&
	   sModule.szExePath[2]=='?'  &&
	   sModule.szExePath[3]=='\\' &&
	   sModule.szExePath[5]==':')
		{
		strncpy(pPath,sModule.szExePath+4,iSize);
		}
	else{
		strncpy(pPath,sModule.szExePath,iSize);
		}

	pPath[iSize-1]=0;
	iLen=strlen(pPath);


return iLen;
}


//*****************************************************************************
//*
//*		Ip6ToString
//*
//*****************************************************************************
//	Konvertiert eine IP Adresse in einen Text
static void Ip6ToString(const unsigned char *pData,char *pIp)
{
int		iPos;
int		iMax;
int		iOff;
int		iLen;



	iMax =  0;
	iLen =  0;
	iOff = -1;

	for(iPos=0;iPos<8;iPos++)					// search for the largest zero area
		{
		if(!pData[iPos*2] && !pData[iPos*2+1])
			{
			iLen++;
			continue;
			}

		if(iLen>iMax)
			{
			iOff=iPos-iLen;
			iMax=iLen;
			}

		iLen=0;
		}

	if(iLen>iMax)
		{
		iOff=iPos-iLen;
		iMax=iLen;
		iLen=0;
		};

	for(iPos=0,iLen=0;iPos<8;iPos++)			// print the values
		{
		if(iPos==iOff)
			{
			if(iPos==0)
				{
				pIp[iLen]=':';
				iLen++;
				}

			pIp[iLen]=':';iLen++;
			iPos += iMax-1;
			continue;
			}

		if(pData[iPos*2])
				iLen+=sprintf(pIp+iLen,"%02X%02X",pData[iPos*2  ],pData[iPos*2+1]);
		else	iLen+=sprintf(pIp+iLen,"%02X"    ,pData[iPos*2+1]);

		if(iPos<7)
			{
			pIp[iLen]=':';
			iLen++;
			}
		}

	pIp[iLen]=0;


}

//*****************************************************************************
//*
//*		Ip4ToString
//*
//*****************************************************************************
//	Konvertiert eine IP Adresse in einen Text
static void Ip4ToString(DWORD dwAddr,char *pIp)
{
union	{
		unsigned long ulValue;
		unsigned char ucData[4];
		}u;


	u.ulValue = dwAddr;
	sprintf(pIp,"%i.%i.%i.%i",u.ucData[0],u.ucData[1],u.ucData[2],u.ucData[3]);


}

//*****************************************************************************
//*
//*		GetTcpTable
//*
//*****************************************************************************
//	pTcpTable	: Puffer in dem die IP-Liste gespeichert wird
//	pSize		: Zeiger auf die Puffergre
//	bOrder		: Die Tabelle sortieren
static DWORD WINAPI GetTcpTable(PMIB_TCPTABLE pTcpTable,PDWORD pSize,BOOL bOrder)
{
static	GetTcpTableType		pProc=0;


	if(!pProc)
		{
		if(!hApiDll)
			{
			hApiDll = LoadLibrary("Iphlpapi.dll");
			}

		if(!pProc)pProc = (GetTcpTableType)GetProcAddress(hApiDll,"GetTcpTable");
		}


	if(!pProc)return ERROR_NOT_SUPPORTED;


return pProc(pTcpTable,pSize,bOrder);
}


//*****************************************************************************
//*
//*		GetUdpTable
//*
//*****************************************************************************
//	pUdpTable	: Puffer in dem die IP-Liste gespeichert wird
//	pSize		: Zeiger auf die Puffergre
//	bOrder		: Die Tabelle sortieren
static DWORD WINAPI GetUdpTable(PMIB_UDPTABLE pUdpTable,PDWORD pSize,BOOL bOrder)
{
static	GetUdpTableType		pProc=0;


	if(!pProc)
		{
		if(!hApiDll)
			{
			hApiDll = LoadLibrary("Iphlpapi.dll");
			}

		if(!pProc)pProc = (GetUdpTableType)GetProcAddress(hApiDll,"GetUdpTable");
		}


	if(!pProc)return ERROR_NOT_SUPPORTED;


return pProc(pUdpTable,pSize,bOrder);
}


//*****************************************************************************
//*
//*		GetExtendedTcpTable
//*
//*****************************************************************************
//	pTcpTable		: Puffer in dem die IP-Liste gespeichert wird
//	pSize			: Zeiger auf die Puffergre
//	bOrder			: Die Tabelle sortieren
//	ulAf			: IP-Type (AF_INET=2 AF_INET6=23)
//	dwTableClass	: TCP_TABLE_OWNER_PID_ALL=5
static DWORD WINAPI GetExtendedTcpTable(PVOID pUdpTable,PDWORD pSize,BOOL bOrder,ULONG ulAf,DWORD dwTableClass,ULONG ulReserved)
{
static	GetExtendedTcpTableType		pProc=0;


	if(!pProc)
		{
		if(!hApiDll)
			{
			hApiDll = LoadLibrary("Iphlpapi.dll");
			}

		if(!pProc)pProc = (GetExtendedTcpTableType)GetProcAddress(hApiDll,"GetExtendedTcpTable");
		}


	if(!pProc)return ERROR_NOT_SUPPORTED;


return pProc(pUdpTable,pSize,bOrder,ulAf,dwTableClass,ulReserved);
}


//*****************************************************************************
//*
//*		GetExtendedUdpTable
//*
//*****************************************************************************
//	pUdpTable		: Puffer in dem die IP-Liste gespeichert wird
//	pSize			: Zeiger auf die Puffergre
//	bOrder			: Die Tabelle sortieren
//	ulAf			: IP-Type (AF_INET=2 AF_INET6=23)
//	dwTableClass	: UDP_TABLE_OWNER_PID_ALL=5
static DWORD WINAPI GetExtendedUdpTable(PVOID pUdpTable,PDWORD pSize,BOOL bOrder,ULONG ulAf,DWORD dwTableClass,ULONG ulReserved)
{
static	GetExtendedUdpTableType		pProc=0;


	if(!pProc)
		{
		if(!hApiDll)
			{
			hApiDll = LoadLibrary("Iphlpapi.dll");
			}

		if(!pProc)pProc = (GetExtendedUdpTableType)GetProcAddress(hApiDll,"GetExtendedUdpTable");
		}


	if(!pProc)return ERROR_NOT_SUPPORTED;


return pProc(pUdpTable,pSize,bOrder,ulAf,dwTableClass,ulReserved);
}


//*****************************************************************************
//*
//*		NetStatState
//*
//*****************************************************************************
const char *NetStatState(unsigned uState)
{

	switch(uState)
		{
	case NSL_TCP_STATE_UDP:			return "UDP";
	case NSL_TCP_STATE_CLOSED:		return "CLOSED";
	case NSL_TCP_STATE_LISTEN:		return "LISTEN";
	case NSL_TCP_STATE_SYN_SENT:	return "SYN SENT";
	case NSL_TCP_STATE_SYN_RCVD:	return "SYN RECIVED";
	case NSL_TCP_STATE_ESTAB:		return "ESTABLISHED";
	case NSL_TCP_STATE_FIN_WAIT1:	return "FIN WAIT1";
	case NSL_TCP_STATE_FIN_WAIT2:	return "FIN WAIT2";
	case NSL_TCP_STATE_CLOSE_WAIT:	return "CLOSE WAIT";
	case NSL_TCP_STATE_CLOSING:		return "CLOSING";
	case NSL_TCP_STATE_LAST_ACK:	return "LAST ACK";
	case NSL_TCP_STATE_TIME_WAIT:	return "TIME WAIT";
	case NSL_TCP_STATE_DELETE_TCB:	return "DELETE";
		}

return "\?\?\?";
}

//*****************************************************************************
//*
//*		NetStatFree
//*
//*****************************************************************************
//	Die Verbindungsinformationen wieder freigeben
void NetStatFree(NetStatEntry *pList)
{
unsigned	uPos;


	if(!pList)return;

	for(uPos=0;pList[uPos].ucType!=0xFF;uPos++)
		{
		if(pList[uPos].usReserved==0)continue;
		delete pList[uPos].pProcessPath;
		}

	delete pList;

}

//*****************************************************************************
//*
//*		NetStatGet
//*
//*****************************************************************************
//	Holt eine Liste mit Verbindungsinformationen holen
//	uFilter		: Filterbits (0=TCP 1=UDP 2=TCPv6 3=UDPv6 16=Pfade auflsen)
//	pCount		: Hier wird die Anzahl der gefundenen Eintrge gespeichert
//	Ergibt einen Zeiger auf die Liste mit den Eintrgen
NetStatEntry *NetStatGet(unsigned uFilter,unsigned *pCount)
{
MIB_TCP6TABLE_OWNER_PID    *pTcpTableV6;
MIB_TCPTABLE_OWNER_PID     *pTcpTableEx;
MIB_TCPTABLE		       *pTcpTable;
MIB_UDP6TABLE_OWNER_PID    *pUdpTableV6;
MIB_UDPTABLE_OWNER_PID     *pUdpTableEx;
MIB_UDPTABLE		       *pUdpTable;
NetStatEntry			   *pList;
DWORD						uNull;
DWORD						uSize;
unsigned					uAll;
unsigned					uRet;
unsigned					uPos;
unsigned					uOff;




	uNull		= 0;
	pTcpTableV6	= (MIB_TCP6TABLE_OWNER_PID*)&uNull;
	pTcpTableEx	= (MIB_TCPTABLE_OWNER_PID *)&uNull;
	pTcpTable	= (MIB_TCPTABLE		      *)&uNull;
	pUdpTableV6	= (MIB_UDP6TABLE_OWNER_PID*)&uNull;
	pUdpTableEx	= (MIB_UDPTABLE_OWNER_PID *)&uNull;
	pUdpTable	= (MIB_UDPTABLE		      *)&uNull;


//******************** TCP V4 *************************************************

	if(uFilter&1)
		{
		uSize	= 2048;

		pTcpTableEx = (MIB_TCPTABLE_OWNER_PID*) new char[uSize];

		   uRet = GetExtendedTcpTable(pTcpTableEx,&uSize,TRUE,AF_INET,TCP_TABLE_OWNER_PID_ALL,0);
		if(uRet==ERROR_INSUFFICIENT_BUFFER)
			{
			delete pTcpTableEx;
			pTcpTableEx = (MIB_TCPTABLE_OWNER_PID*) new char[uSize];
			uRet        = GetExtendedTcpTable(pTcpTableEx,&uSize,TRUE,AF_INET,TCP_TABLE_OWNER_PID_ALL,0);
			}

		if(uRet!=ERROR_SUCCESS)
			{
			delete pTcpTableEx;
			pTcpTableEx	= (MIB_TCPTABLE_OWNER_PID*)&uNull;

			uSize	= 2048;

			pTcpTable = (MIB_TCPTABLE*) new char[uSize];

			   uRet = GetTcpTable(pTcpTable,&uSize,TRUE);
			if(uRet==ERROR_INSUFFICIENT_BUFFER)
				{
				delete pTcpTable;
				pTcpTable = (MIB_TCPTABLE*) new char[uSize];
				uRet      = GetTcpTable(pTcpTable,&uSize,TRUE);
				}

			if(uRet!=ERROR_SUCCESS)
				{
				delete pTcpTable;
				pTcpTable	= (MIB_TCPTABLE*)&uNull;
				}
			}
		}


//******************** UDP V4 *************************************************

	if(uFilter&2)
		{
		uSize	= 2048;

		pUdpTableEx = (MIB_UDPTABLE_OWNER_PID*) new char[uSize];

		   uRet = GetExtendedUdpTable(pUdpTableEx,&uSize,TRUE,AF_INET,UDP_TABLE_OWNER_PID,0);
		if(uRet==ERROR_INSUFFICIENT_BUFFER)
			{
			delete pUdpTableEx;
			pUdpTableEx = (MIB_UDPTABLE_OWNER_PID*) new char[uSize];
			uRet        = GetExtendedUdpTable(pUdpTableEx,&uSize,TRUE,AF_INET,UDP_TABLE_OWNER_PID,0);
			}

		if(uRet!=ERROR_SUCCESS)
			{
			delete pUdpTableEx;
			pUdpTableEx	= (MIB_UDPTABLE_OWNER_PID*)&uNull;

			uSize	= 2048;

			pUdpTable = (MIB_UDPTABLE*) new char[uSize];

			   uRet = GetUdpTable(pUdpTable,&uSize,TRUE);
			if(uRet==ERROR_INSUFFICIENT_BUFFER)
				{
				delete pUdpTable;
				pUdpTable = (MIB_UDPTABLE*) new char[uSize];
				uRet      = GetUdpTable(pUdpTable,&uSize,TRUE);
				}

			if(uRet!=ERROR_SUCCESS)
				{
				delete pUdpTable;
				pUdpTable	= (MIB_UDPTABLE*)&uNull;
				}
			}
		}

//******************** TCP V6 *************************************************

	if(uFilter&4)
		{
		uSize	= 2048;

		pTcpTableV6 = (MIB_TCP6TABLE_OWNER_PID*) new char[uSize];

		   uRet = GetExtendedTcpTable(pTcpTableV6,&uSize,TRUE,AF_INET6,TCP_TABLE_OWNER_PID_ALL,0);
		if(uRet==ERROR_INSUFFICIENT_BUFFER)
			{
			delete pTcpTableV6;
			pTcpTableV6 = (MIB_TCP6TABLE_OWNER_PID*) new char[uSize];
			uRet        = GetExtendedTcpTable(pTcpTableV6,&uSize,TRUE,AF_INET6,TCP_TABLE_OWNER_PID_ALL,0);
			}

		if(uRet!=ERROR_SUCCESS)
			{
			delete pUdpTableV6;
			pTcpTableV6	= (MIB_TCP6TABLE_OWNER_PID*)&uNull;
			}
		}

//******************** UDP V6 *************************************************

	if(uFilter&8)
		{
		uSize	= 2048;

		pUdpTableV6 = (MIB_UDP6TABLE_OWNER_PID*) new char[uSize];

		   uRet = GetExtendedUdpTable(pUdpTableV6,&uSize,TRUE,AF_INET6,UDP_TABLE_OWNER_PID,0);
		if(uRet==ERROR_INSUFFICIENT_BUFFER)
			{
			delete pUdpTableV6;
			pUdpTableEx = (MIB_UDPTABLE_OWNER_PID*) new char[uSize];
			uRet        = GetExtendedUdpTable(pUdpTableV6,&uSize,TRUE,AF_INET6,UDP_TABLE_OWNER_PID,0);
			}

		if(uRet!=ERROR_SUCCESS)
			{
			delete pUdpTableV6;
			pUdpTableV6	= (MIB_UDP6TABLE_OWNER_PID*)&uNull;
			}
		}


//******************** Liste erstellen ****************************************


	uAll	= pTcpTableV6->dwNumEntries;
	uAll   += pTcpTableEx->dwNumEntries;
	uAll   += pTcpTable  ->dwNumEntries;
	uAll   += pUdpTableV6->dwNumEntries;
	uAll   += pUdpTableEx->dwNumEntries;
	uAll   += pUdpTable  ->dwNumEntries;


	pList	= new NetStatEntry[uAll+1];
	pList[uAll].ucType = 0xFF;

	if(pCount)*pCount=uAll;

	uPos = 0;

	for(uOff=0;uOff<pTcpTableEx->dwNumEntries;uOff++,uPos++)
		{
		pList[uPos].ucType			= 0;
		pList[uPos].ucState			= (BYTE )pTcpTableEx->table[uOff].dwState;
		pList[uPos].usLocalPort		= BETOLE(pTcpTableEx->table[uOff].dwLocalPort);
		pList[uPos].usRemotePort	= BETOLE(pTcpTableEx->table[uOff].dwRemotePort);
		pList[uPos].uProcessId		=        pTcpTableEx->table[uOff].dwOwningPid;

		Ip4ToString(pTcpTableEx->table[uOff].dwLocalAddr ,pList[uPos].cLocalAddr );
		Ip4ToString(pTcpTableEx->table[uOff].dwRemoteAddr,pList[uPos].cRemoteAddr);
		}

	for(uOff=0;uOff<pTcpTable->dwNumEntries;uOff++,uPos++)
		{
		pList[uPos].ucType			= 0;
		pList[uPos].ucState			= (BYTE )pTcpTable->table[uOff].dwState;
		pList[uPos].usLocalPort		= BETOLE(pTcpTable->table[uOff].dwLocalPort);
		pList[uPos].usRemotePort	= BETOLE(pTcpTable->table[uOff].dwRemotePort);
		pList[uPos].uProcessId		= 0;

		Ip4ToString(pTcpTable->table[uOff].dwLocalAddr ,pList[uPos].cLocalAddr );
		Ip4ToString(pTcpTable->table[uOff].dwRemoteAddr,pList[uPos].cRemoteAddr);
		}

	for(uOff=0;uOff<pTcpTableV6->dwNumEntries;uOff++,uPos++)
		{
		pList[uPos].ucType			= 2;
		pList[uPos].ucState			= (BYTE)pTcpTableV6->table[uOff].dwState;
		pList[uPos].usLocalPort		= BETOLE(pTcpTableV6->table[uOff].dwLocalPort);
		pList[uPos].usRemotePort	= BETOLE(pTcpTableV6->table[uOff].dwRemotePort);
		pList[uPos].uProcessId		=        pTcpTableV6->table[uOff].dwOwningPid;

		Ip6ToString(pTcpTableV6->table[uOff].ucLocalAddr ,pList[uPos].cLocalAddr );
		Ip6ToString(pTcpTableV6->table[uOff].ucRemoteAddr,pList[uPos].cRemoteAddr);
		}


	for(uOff=0;uOff<pUdpTableEx->dwNumEntries;uOff++,uPos++)
		{
		pList[uPos].cRemoteAddr[0]	= 0;
		pList[uPos].usRemotePort	= 0;
		pList[uPos].ucType			= 1;
		pList[uPos].ucState			= 0;
		pList[uPos].usLocalPort		= BETOLE(pUdpTableEx->table[uOff].dwLocalPort);
		pList[uPos].uProcessId		=        pUdpTableEx->table[uOff].dwOwningPid;

		Ip4ToString(pUdpTableEx->table[uOff].dwLocalAddr ,pList[uPos].cLocalAddr);
		}

	for(uOff=0;uOff<pUdpTable->dwNumEntries;uOff++,uPos++)
		{
		pList[uPos].cRemoteAddr[0]	= 0;
		pList[uPos].usRemotePort	= 0;
		pList[uPos].ucType			= 1;
		pList[uPos].ucState			= 0;
		pList[uPos].usLocalPort		= BETOLE(pUdpTable->table[uOff].dwLocalPort);
		pList[uPos].uProcessId		= 0;

		Ip4ToString(pUdpTable->table[uOff].dwLocalAddr ,pList[uPos].cLocalAddr);
		}

	for(uOff=0;uOff<pUdpTableV6->dwNumEntries;uOff++,uPos++)
		{
		pList[uPos].cRemoteAddr[0]	= 0;
		pList[uPos].usRemotePort	= 0;
		pList[uPos].ucType			= 3;
		pList[uPos].ucState			= 0;
		pList[uPos].usLocalPort		= BETOLE(pUdpTableV6->table[uOff].dwLocalPort);
		pList[uPos].uProcessId		=        pUdpTableV6->table[uOff].dwOwningPid;

		Ip6ToString(pUdpTableV6->table[uOff].ucLocalAddr ,pList[uPos].cLocalAddr);
		}

 //******************* Prozessnamen auflsen **********************************

	if(uFilter&0x10000)
		{
		for(uPos=0;uPos<uAll;uPos++)
			{
			for(uOff=uPos;;)
				{
				if(uOff==0)
					{
					char	cPath[MAX_PATH];

						uRet=ProcessPathFormId(pList[uPos].uProcessId,cPath,MAX_PATH);
					if(!uRet)
						{
						pList[uPos].pProcessPath = "";
						pList[uPos].pProcessName = "";
						pList[uPos].usReserved   = 0;
						break;
						}

					pList[uPos].pProcessPath = new char[uRet+1];
					memcpy(pList[uPos].pProcessPath,cPath,uRet+1);

					while(uRet>0)
						{
						if(cPath[uRet-1]=='\\')break;
						uRet--;
						}

					pList[uPos].pProcessName = pList[uPos].pProcessPath+uRet;
					pList[uPos].usReserved	 = 1;
					break;
					}

				uOff--;

				if(pList[uPos].uProcessId!=pList[uOff].uProcessId)
					{
					continue;
					}

				pList[uPos].pProcessPath = pList[uOff].pProcessPath;
				pList[uPos].pProcessName = pList[uOff].pProcessName;
				pList[uPos].usReserved	 = 0;
				}
			}
		}
	else{
		for(uPos=0;uPos<uAll;uPos++)
			{
			pList[uPos].pProcessPath = "";
			pList[uPos].pProcessName = "";
			pList[uPos].usReserved	 = 0;
			}
		}



	uNull = 0xFFFFFFFF;

	if(pTcpTableV6->dwNumEntries!=0xFFFFFFFF)delete pTcpTableV6;
	if(pTcpTableEx->dwNumEntries!=0xFFFFFFFF)delete pTcpTableEx;
	if(pTcpTable  ->dwNumEntries!=0xFFFFFFFF)delete pTcpTable;
	if(pUdpTableV6->dwNumEntries!=0xFFFFFFFF)delete pUdpTableV6;
	if(pUdpTableEx->dwNumEntries!=0xFFFFFFFF)delete pUdpTableEx;
	if(pUdpTable  ->dwNumEntries!=0xFFFFFFFF)delete pUdpTable;



return pList;
}

//*****************************************************************************
//*
//*		NetStatPath
//*
//*****************************************************************************
//	ndert den Pfad eine es Listeneintrages.
//	pList		: Ist der Zeiger auf den Listeneintrag
//	pPath		: Ist der neue Pfad
//	uProcessId	: Ist die ID des Prozesses
void NetStatPath(NetStatEntry *pList,const char *pPath,unsigned uProcessId)
{
char   *pNew;
char   *pOld;
int		iLen;
int		iOff;


	if(!pList || !pPath)return;

	iLen = strlen(pPath);

	for(iOff=iLen;iLen>0;iOff--)				// Suche Dateinamen im Pfad
		{
		if(pPath[iOff-1]=='\\')break;
		if(pPath[iOff-1]=='/' )break;
		}

	pOld	= pList->pProcessPath;
	pNew	= new char[iLen+1];
	memcpy(pNew,pPath,iLen+1);

	pList->pProcessPath		= pNew;
	pList->pProcessName		= pNew+iOff;

	if(pOld && pList->usReserved)
		{
		delete pOld;
		}

	pList->usReserved = 1;
}
