//*****************************************************************************
//*
//*
//*		NetStatLib.h
//*
//*
//*****************************************************************************
//
//	Source-Code Beispiel:
//
//		NetStatEntry	*pList;
//		unsigned		 uPos;
//
//			pList = NetStatGet();
//		if(!pList)return;
//
//		for(uPos=0;;uPos++)
//			{
//			if(pList[uPos].ucType==0xFF)break;
//
//			printf("%s:%i -> %s:%i = %s\n",
//						pList[uPos].cLocalAddr ,pList[uPos].usLocalPort ,
//						pList[uPos].cRemoteAddr,pList[uPos].usRemotePort,
//						NetStatState(pList[uPos].ucState));
//			}
//
//		NetStatFree(pList);
//
#ifndef 	__NETSTATLIB_H__
#define 	__NETSTATLIB_H__


#define 	NSL_TCP_STATE_UDP			0
#define 	NSL_TCP_STATE_CLOSED		1
#define 	NSL_TCP_STATE_LISTEN		2
#define 	NSL_TCP_STATE_SYN_SENT		3
#define 	NSL_TCP_STATE_SYN_RCVD		4
#define 	NSL_TCP_STATE_ESTAB			5
#define 	NSL_TCP_STATE_FIN_WAIT1		6
#define 	NSL_TCP_STATE_FIN_WAIT2		7
#define 	NSL_TCP_STATE_CLOSE_WAIT	8
#define 	NSL_TCP_STATE_CLOSING		9
#define 	NSL_TCP_STATE_LAST_ACK		10
#define 	NSL_TCP_STATE_TIME_WAIT		11
#define 	NSL_TCP_STATE_DELETE_TCB	12
#define		NSL_TCP_STATE_UNKNOWN		13


typedef struct
	{
	unsigned char	ucType;								// 0=TCP 1=UDP 2=TCPv6 3=UDPv6 0xFF=Ende
	unsigned char	ucState;
	unsigned short	usReserved;
	unsigned short	usLocalPort;
	unsigned short	usRemotePort;
	char			cLocalAddr [40];
	char			cRemoteAddr[40];
	unsigned		uProcessId;
	char		   *pProcessPath;
	char		   *pProcessName;
	}NetStatEntry;


const char	   *NetStatState(unsigned uState);
NetStatEntry   *NetStatGet(unsigned uFilter=0x1000F,unsigned *pCount=0);
void			NetStatFree(NetStatEntry *pList);
void			NetStatPath(NetStatEntry *pList,const char *pPath,unsigned uProcessId);


#endif
